/* this program goes thru BIOS and displays the list of disk type nums */

#include <stdio.h>
#include <conio.h>
#include <dos.h>

#define uint  unsigned int
#define uchar unsigned char

typedef struct {
	uint	cyls;
	uchar	heads;
	uint	filler1;
	uint	Write_Pre_Comp;
	uchar	filler3;
	uchar	control_byte;
	uchar	filler4[3];
	uint	landing_zone;
	uchar	sectors;
	uchar	last;
	} DiskParams;

char ValidDPEntry(DiskParams * DP) {
	return(	DP->filler1==0    &&
                DP->filler3==0    &&
		DP->filler4[0]==0 &&
		DP->filler4[1]==0 &&
		DP->filler4[2]==0 &&
		DP->last==0       &&
		DP->heads   < 32  &&
		DP->sectors < 64  &&
		DP->cyls  < 3000 );
}

void PrintDiskParam(DiskParams * DP, char num) {
	int mb;
	if (DP->cyls==0)
		printf(" %2d  <not installed>\n", num);
	else {
		mb = ((long)DP->cyls * DP->heads * DP->sectors * 512) / 1000000;
		printf(" %2d  %4d  %2d  %2d %3d\n",
			num, DP->cyls, DP->heads, DP->sectors, mb);
	}
}

void PrintDPHeader() {
	printf("Type Cyls  Hd  Se  MB\n");
}

DiskParams *GetDPStart() {
	DiskParams * DP;
	DP = (DiskParams*)getvect(0x41);
	if (DP==NULL) return(DP);
	while (ValidDPEntry(DP)) DP--;
	return(DP);
}

void main () {
DiskParams * DP;
char	N=0,
	ScrCnt=0;


DP = GetDPStart();
if (DP) {
	PrintDPHeader();
	while ( ValidDPEntry(++DP) ) {
		PrintDiskParam(DP, ++N);
		if (++ScrCnt==22) {
			printf(". . . pause . . .");
                        getch();
			printf("\n");
			ScrCnt=0;
		}
	}
}
}